// Code generated by protoc-gen-validate. DO NOT EDIT.
// source: pb/author.proto

package authorpb

import (
	"bytes"
	"errors"
	"fmt"
	"net"
	"net/mail"
	"net/url"
	"regexp"
	"strings"
	"time"
	"unicode/utf8"

	"github.com/golang/protobuf/ptypes"
)

// ensure the imports are used
var (
	_ = bytes.MinRead
	_ = errors.New("")
	_ = fmt.Print
	_ = utf8.UTFMax
	_ = (*regexp.Regexp)(nil)
	_ = (*strings.Reader)(nil)
	_ = net.IPv4len
	_ = time.Duration(0)
	_ = (*url.URL)(nil)
	_ = (*mail.Address)(nil)
	_ = ptypes.DynamicAny{}
)

// Validate checks the field values on Author with the rules defined in the
// proto definition for this message. If any rules are violated, an error is returned.
func (m *Author) Validate() error {
	if m == nil {
		return nil
	}

	if utf8.RuneCountInString(m.GetId()) < 1 {
		return AuthorValidationError{
			field:  "Id",
			reason: "value length must be at least 1 runes",
		}
	}

	if utf8.RuneCountInString(m.GetName()) < 1 {
		return AuthorValidationError{
			field:  "Name",
			reason: "value length must be at least 1 runes",
		}
	}

	if utf8.RuneCountInString(m.GetEmail()) < 1 {
		return AuthorValidationError{
			field:  "Email",
			reason: "value length must be at least 1 runes",
		}
	}

	// no validation rules for Phone

	return nil
}

// AuthorValidationError is the validation error returned by Author.Validate if
// the designated constraints aren't met.
type AuthorValidationError struct {
	field  string
	reason string
	cause  error
	key    bool
}

// Field function returns field value.
func (e AuthorValidationError) Field() string { return e.field }

// Reason function returns reason value.
func (e AuthorValidationError) Reason() string { return e.reason }

// Cause function returns cause value.
func (e AuthorValidationError) Cause() error { return e.cause }

// Key function returns key value.
func (e AuthorValidationError) Key() bool { return e.key }

// ErrorName returns error name.
func (e AuthorValidationError) ErrorName() string { return "AuthorValidationError" }

// Error satisfies the builtin error interface
func (e AuthorValidationError) Error() string {
	cause := ""
	if e.cause != nil {
		cause = fmt.Sprintf(" | caused by: %v", e.cause)
	}

	key := ""
	if e.key {
		key = "key for "
	}

	return fmt.Sprintf(
		"invalid %sAuthor.%s: %s%s",
		key,
		e.field,
		e.reason,
		cause)
}

var _ error = AuthorValidationError{}

var _ interface {
	Field() string
	Reason() string
	Key() bool
	Cause() error
	ErrorName() string
} = AuthorValidationError{}

// Validate checks the field values on CreateAuthorRequest with the rules
// defined in the proto definition for this message. If any rules are
// violated, an error is returned.
func (m *CreateAuthorRequest) Validate() error {
	if m == nil {
		return nil
	}

	if m.GetAuthor() == nil {
		return CreateAuthorRequestValidationError{
			field:  "Author",
			reason: "value is required",
		}
	}

	if v, ok := interface{}(m.GetAuthor()).(interface{ Validate() error }); ok {
		if err := v.Validate(); err != nil {
			return CreateAuthorRequestValidationError{
				field:  "Author",
				reason: "embedded message failed validation",
				cause:  err,
			}
		}
	}

	return nil
}

// CreateAuthorRequestValidationError is the validation error returned by
// CreateAuthorRequest.Validate if the designated constraints aren't met.
type CreateAuthorRequestValidationError struct {
	field  string
	reason string
	cause  error
	key    bool
}

// Field function returns field value.
func (e CreateAuthorRequestValidationError) Field() string { return e.field }

// Reason function returns reason value.
func (e CreateAuthorRequestValidationError) Reason() string { return e.reason }

// Cause function returns cause value.
func (e CreateAuthorRequestValidationError) Cause() error { return e.cause }

// Key function returns key value.
func (e CreateAuthorRequestValidationError) Key() bool { return e.key }

// ErrorName returns error name.
func (e CreateAuthorRequestValidationError) ErrorName() string {
	return "CreateAuthorRequestValidationError"
}

// Error satisfies the builtin error interface
func (e CreateAuthorRequestValidationError) Error() string {
	cause := ""
	if e.cause != nil {
		cause = fmt.Sprintf(" | caused by: %v", e.cause)
	}

	key := ""
	if e.key {
		key = "key for "
	}

	return fmt.Sprintf(
		"invalid %sCreateAuthorRequest.%s: %s%s",
		key,
		e.field,
		e.reason,
		cause)
}

var _ error = CreateAuthorRequestValidationError{}

var _ interface {
	Field() string
	Reason() string
	Key() bool
	Cause() error
	ErrorName() string
} = CreateAuthorRequestValidationError{}

// Validate checks the field values on GetAuthorRequest with the rules defined
// in the proto definition for this message. If any rules are violated, an
// error is returned.
func (m *GetAuthorRequest) Validate() error {
	if m == nil {
		return nil
	}

	if utf8.RuneCountInString(m.GetId()) < 1 {
		return GetAuthorRequestValidationError{
			field:  "Id",
			reason: "value length must be at least 1 runes",
		}
	}

	if v, ok := interface{}(m.GetViewMask()).(interface{ Validate() error }); ok {
		if err := v.Validate(); err != nil {
			return GetAuthorRequestValidationError{
				field:  "ViewMask",
				reason: "embedded message failed validation",
				cause:  err,
			}
		}
	}

	return nil
}

// GetAuthorRequestValidationError is the validation error returned by
// GetAuthorRequest.Validate if the designated constraints aren't met.
type GetAuthorRequestValidationError struct {
	field  string
	reason string
	cause  error
	key    bool
}

// Field function returns field value.
func (e GetAuthorRequestValidationError) Field() string { return e.field }

// Reason function returns reason value.
func (e GetAuthorRequestValidationError) Reason() string { return e.reason }

// Cause function returns cause value.
func (e GetAuthorRequestValidationError) Cause() error { return e.cause }

// Key function returns key value.
func (e GetAuthorRequestValidationError) Key() bool { return e.key }

// ErrorName returns error name.
func (e GetAuthorRequestValidationError) ErrorName() string { return "GetAuthorRequestValidationError" }

// Error satisfies the builtin error interface
func (e GetAuthorRequestValidationError) Error() string {
	cause := ""
	if e.cause != nil {
		cause = fmt.Sprintf(" | caused by: %v", e.cause)
	}

	key := ""
	if e.key {
		key = "key for "
	}

	return fmt.Sprintf(
		"invalid %sGetAuthorRequest.%s: %s%s",
		key,
		e.field,
		e.reason,
		cause)
}

var _ error = GetAuthorRequestValidationError{}

var _ interface {
	Field() string
	Reason() string
	Key() bool
	Cause() error
	ErrorName() string
} = GetAuthorRequestValidationError{}

// Validate checks the field values on UpdateAuthorRequest with the rules
// defined in the proto definition for this message. If any rules are
// violated, an error is returned.
func (m *UpdateAuthorRequest) Validate() error {
	if m == nil {
		return nil
	}

	if m.GetAuthor() == nil {
		return UpdateAuthorRequestValidationError{
			field:  "Author",
			reason: "value is required",
		}
	}

	if v, ok := interface{}(m.GetAuthor()).(interface{ Validate() error }); ok {
		if err := v.Validate(); err != nil {
			return UpdateAuthorRequestValidationError{
				field:  "Author",
				reason: "embedded message failed validation",
				cause:  err,
			}
		}
	}

	if v, ok := interface{}(m.GetUpdateMask()).(interface{ Validate() error }); ok {
		if err := v.Validate(); err != nil {
			return UpdateAuthorRequestValidationError{
				field:  "UpdateMask",
				reason: "embedded message failed validation",
				cause:  err,
			}
		}
	}

	return nil
}

// UpdateAuthorRequestValidationError is the validation error returned by
// UpdateAuthorRequest.Validate if the designated constraints aren't met.
type UpdateAuthorRequestValidationError struct {
	field  string
	reason string
	cause  error
	key    bool
}

// Field function returns field value.
func (e UpdateAuthorRequestValidationError) Field() string { return e.field }

// Reason function returns reason value.
func (e UpdateAuthorRequestValidationError) Reason() string { return e.reason }

// Cause function returns cause value.
func (e UpdateAuthorRequestValidationError) Cause() error { return e.cause }

// Key function returns key value.
func (e UpdateAuthorRequestValidationError) Key() bool { return e.key }

// ErrorName returns error name.
func (e UpdateAuthorRequestValidationError) ErrorName() string {
	return "UpdateAuthorRequestValidationError"
}

// Error satisfies the builtin error interface
func (e UpdateAuthorRequestValidationError) Error() string {
	cause := ""
	if e.cause != nil {
		cause = fmt.Sprintf(" | caused by: %v", e.cause)
	}

	key := ""
	if e.key {
		key = "key for "
	}

	return fmt.Sprintf(
		"invalid %sUpdateAuthorRequest.%s: %s%s",
		key,
		e.field,
		e.reason,
		cause)
}

var _ error = UpdateAuthorRequestValidationError{}

var _ interface {
	Field() string
	Reason() string
	Key() bool
	Cause() error
	ErrorName() string
} = UpdateAuthorRequestValidationError{}

// Validate checks the field values on DeleteAuthorRequest with the rules
// defined in the proto definition for this message. If any rules are
// violated, an error is returned.
func (m *DeleteAuthorRequest) Validate() error {
	if m == nil {
		return nil
	}

	if utf8.RuneCountInString(m.GetId()) < 1 {
		return DeleteAuthorRequestValidationError{
			field:  "Id",
			reason: "value length must be at least 1 runes",
		}
	}

	return nil
}

// DeleteAuthorRequestValidationError is the validation error returned by
// DeleteAuthorRequest.Validate if the designated constraints aren't met.
type DeleteAuthorRequestValidationError struct {
	field  string
	reason string
	cause  error
	key    bool
}

// Field function returns field value.
func (e DeleteAuthorRequestValidationError) Field() string { return e.field }

// Reason function returns reason value.
func (e DeleteAuthorRequestValidationError) Reason() string { return e.reason }

// Cause function returns cause value.
func (e DeleteAuthorRequestValidationError) Cause() error { return e.cause }

// Key function returns key value.
func (e DeleteAuthorRequestValidationError) Key() bool { return e.key }

// ErrorName returns error name.
func (e DeleteAuthorRequestValidationError) ErrorName() string {
	return "DeleteAuthorRequestValidationError"
}

// Error satisfies the builtin error interface
func (e DeleteAuthorRequestValidationError) Error() string {
	cause := ""
	if e.cause != nil {
		cause = fmt.Sprintf(" | caused by: %v", e.cause)
	}

	key := ""
	if e.key {
		key = "key for "
	}

	return fmt.Sprintf(
		"invalid %sDeleteAuthorRequest.%s: %s%s",
		key,
		e.field,
		e.reason,
		cause)
}

var _ error = DeleteAuthorRequestValidationError{}

var _ interface {
	Field() string
	Reason() string
	Key() bool
	Cause() error
	ErrorName() string
} = DeleteAuthorRequestValidationError{}

// Validate checks the field values on ListAuthorsRequest with the rules
// defined in the proto definition for this message. If any rules are
// violated, an error is returned.
func (m *ListAuthorsRequest) Validate() error {
	if m == nil {
		return nil
	}

	if v, ok := interface{}(m.GetViewMask()).(interface{ Validate() error }); ok {
		if err := v.Validate(); err != nil {
			return ListAuthorsRequestValidationError{
				field:  "ViewMask",
				reason: "embedded message failed validation",
				cause:  err,
			}
		}
	}

	return nil
}

// ListAuthorsRequestValidationError is the validation error returned by
// ListAuthorsRequest.Validate if the designated constraints aren't met.
type ListAuthorsRequestValidationError struct {
	field  string
	reason string
	cause  error
	key    bool
}

// Field function returns field value.
func (e ListAuthorsRequestValidationError) Field() string { return e.field }

// Reason function returns reason value.
func (e ListAuthorsRequestValidationError) Reason() string { return e.reason }

// Cause function returns cause value.
func (e ListAuthorsRequestValidationError) Cause() error { return e.cause }

// Key function returns key value.
func (e ListAuthorsRequestValidationError) Key() bool { return e.key }

// ErrorName returns error name.
func (e ListAuthorsRequestValidationError) ErrorName() string {
	return "ListAuthorsRequestValidationError"
}

// Error satisfies the builtin error interface
func (e ListAuthorsRequestValidationError) Error() string {
	cause := ""
	if e.cause != nil {
		cause = fmt.Sprintf(" | caused by: %v", e.cause)
	}

	key := ""
	if e.key {
		key = "key for "
	}

	return fmt.Sprintf(
		"invalid %sListAuthorsRequest.%s: %s%s",
		key,
		e.field,
		e.reason,
		cause)
}

var _ error = ListAuthorsRequestValidationError{}

var _ interface {
	Field() string
	Reason() string
	Key() bool
	Cause() error
	ErrorName() string
} = ListAuthorsRequestValidationError{}

// Validate checks the field values on ListAuthorsResponse with the rules
// defined in the proto definition for this message. If any rules are
// violated, an error is returned.
func (m *ListAuthorsResponse) Validate() error {
	if m == nil {
		return nil
	}

	for idx, item := range m.GetAuthors() {
		_, _ = idx, item

		if v, ok := interface{}(item).(interface{ Validate() error }); ok {
			if err := v.Validate(); err != nil {
				return ListAuthorsResponseValidationError{
					field:  fmt.Sprintf("Authors[%v]", idx),
					reason: "embedded message failed validation",
					cause:  err,
				}
			}
		}

	}

	return nil
}

// ListAuthorsResponseValidationError is the validation error returned by
// ListAuthorsResponse.Validate if the designated constraints aren't met.
type ListAuthorsResponseValidationError struct {
	field  string
	reason string
	cause  error
	key    bool
}

// Field function returns field value.
func (e ListAuthorsResponseValidationError) Field() string { return e.field }

// Reason function returns reason value.
func (e ListAuthorsResponseValidationError) Reason() string { return e.reason }

// Cause function returns cause value.
func (e ListAuthorsResponseValidationError) Cause() error { return e.cause }

// Key function returns key value.
func (e ListAuthorsResponseValidationError) Key() bool { return e.key }

// ErrorName returns error name.
func (e ListAuthorsResponseValidationError) ErrorName() string {
	return "ListAuthorsResponseValidationError"
}

// Error satisfies the builtin error interface
func (e ListAuthorsResponseValidationError) Error() string {
	cause := ""
	if e.cause != nil {
		cause = fmt.Sprintf(" | caused by: %v", e.cause)
	}

	key := ""
	if e.key {
		key = "key for "
	}

	return fmt.Sprintf(
		"invalid %sListAuthorsResponse.%s: %s%s",
		key,
		e.field,
		e.reason,
		cause)
}

var _ error = ListAuthorsResponseValidationError{}

var _ interface {
	Field() string
	Reason() string
	Key() bool
	Cause() error
	ErrorName() string
} = ListAuthorsResponseValidationError{}
